diff --git a/gcc/tree-ssa-structalias.c b/gcc/tree-ssa-structalias.c
index 8201cb4..8ea1780 100644
--- a/gcc/tree-ssa-structalias.c
+++ b/gcc/tree-ssa-structalias.c
@@ -3372,7 +3372,7 @@ get_constraint_for_1 (tree t, vec<ce_s> *results, bool address_p,
       || (TREE_CODE (t) == CONSTRUCTOR
 	  && CONSTRUCTOR_NELTS (t) == 0))
     {
-      if (flag_delete_null_pointer_checks)
+      if (GCC_OPTION (flag_delete_null_pointer_checks))
 	temp.var = nothing_id;
       else
 	temp.var = nonlocal_id;
@@ -4224,7 +4224,7 @@ find_func_aliases_for_builtin_call (gimple t)
 	    }
 	  get_constraint_for_ptr_offset (dest, NULL_TREE, &lhsc);
 	  do_deref (&lhsc);
-	  if (flag_delete_null_pointer_checks
+	  if (GCC_OPTION (flag_delete_null_pointer_checks)
 	      && integer_zerop (gimple_call_arg (t, 1)))
 	    {
 	      ac.type = ADDRESSOF;
@@ -6992,7 +6992,7 @@ compute_may_aliases (void)
 static bool
 gate_tree_pta (void)
 {
-  return flag_tree_pta;
+  return GCC_OPTION (flag_tree_pta);
 }
 
 /* A dummy pass to cause points-to information to be computed via
@@ -7080,8 +7080,8 @@ make_pass_build_ealias (gcc::context *ctxt)
 static bool
 gate_ipa_pta (void)
 {
-  return (optimize
-	  && flag_ipa_pta
+  return (GCC_OPTION (optimize)
+	  && GCC_OPTION (flag_ipa_pta)
 	  /* Don't bother doing anything if the program has errors.  */
 	  && !seen_error ());
 }
diff --git a/gcc/tree-ssa-tail-merge.c b/gcc/tree-ssa-tail-merge.c
index f6b1ba0..12bfdd3 100644
--- a/gcc/tree-ssa-tail-merge.c
+++ b/gcc/tree-ssa-tail-merge.c
@@ -1655,7 +1655,7 @@ tail_merge_optimize (unsigned int todo)
   int iteration_nr = 0;
   int max_iterations = PARAM_VALUE (PARAM_MAX_TAIL_MERGE_ITERATIONS);
 
-  if (!flag_tree_tail_merge
+  if (!GCC_OPTION (flag_tree_tail_merge)
       || max_iterations == 0
       /* We try to be conservative with respect to loop structure, since:
 	 - the cases where tail-merging could both affect loop structure and be
diff --git a/gcc/tree-ssa-ter.c b/gcc/tree-ssa-ter.c
index 09dc313..8c7e0f9 100644
--- a/gcc/tree-ssa-ter.c
+++ b/gcc/tree-ssa-ter.c
@@ -436,13 +436,13 @@ ter_is_replaceable_p (gimple stmt)
       block2 = LOCATION_BLOCK (locus2);
       locus2 = LOCATION_LOCUS (locus2);
 
-      if ((!optimize || optimize_debug)
+      if ((!GCC_OPTION (optimize) || GCC_OPTION (optimize_debug))
 	  && ((locus1 != UNKNOWN_LOCATION && locus1 != locus2)
 	      || (block1 != NULL_TREE && block1 != block2)))
 	return false;
 
       /* Without alias info we can't move around loads.  */
-      if (!optimize && gimple_assign_single_p (stmt)
+      if (!GCC_OPTION (optimize) && gimple_assign_single_p (stmt)
 	  && !is_gimple_val (gimple_assign_rhs1 (stmt)))
 	return false;
 
diff --git a/gcc/tree-ssa-uncprop.c b/gcc/tree-ssa-uncprop.c
index a43dd1a..45a0eaa 100644
--- a/gcc/tree-ssa-uncprop.c
+++ b/gcc/tree-ssa-uncprop.c
@@ -584,7 +584,7 @@ uncprop_dom_walker::before_dom_children (basic_block bb)
 static bool
 gate_uncprop (void)
 {
-  return flag_tree_dom != 0;
+  return GCC_OPTION (flag_tree_dom) != 0;
 }
 
 namespace {
diff --git a/gcc/tree-ssa-uninit.c b/gcc/tree-ssa-uninit.c
index eee83f7..ed9374a 100644
--- a/gcc/tree-ssa-uninit.c
+++ b/gcc/tree-ssa-uninit.c
@@ -2355,7 +2355,7 @@ execute_late_warn_uninitialized (void)
 static bool
 gate_warn_uninitialized (void)
 {
-  return warn_uninitialized || warn_maybe_uninitialized;
+  return GCC_OPTION (warn_uninitialized) || GCC_OPTION (warn_maybe_uninitialized);
 }
 
 namespace {
@@ -2408,7 +2408,7 @@ execute_early_warn_uninitialized (void)
      optimization we need to warn here about "may be uninitialized".  */
   calculate_dominance_info (CDI_POST_DOMINATORS);
 
-  warn_uninitialized_vars (/*warn_possibly_uninitialized=*/!optimize);
+  warn_uninitialized_vars (/*warn_possibly_uninitialized=*/!GCC_OPTION (optimize));
 
   /* Post-dominator information can not be reliably updated. Free it
      after the use.  */
diff --git a/gcc/tree-streamer-out.c b/gcc/tree-streamer-out.c
index 646fba5..d9dc766 100644
--- a/gcc/tree-streamer-out.c
+++ b/gcc/tree-streamer-out.c
@@ -320,7 +320,7 @@ pack_ts_type_common_value_fields (struct bitpack_d *bp, tree expr)
   /* Make sure to preserve the fact whether the frontend would assign
      alias-set zero to this type.  */
   bp_pack_var_len_int (bp, (TYPE_ALIAS_SET (expr) == 0
-			    || (!in_lto_p
+			    || (!GCC_OPTION (in_lto_p)
 				&& get_alias_set (expr) == 0)) ? 0 : -1);
 }
 
diff --git a/gcc/tree-switch-conversion.c b/gcc/tree-switch-conversion.c
index 547ac9e..cabaf7e 100644
--- a/gcc/tree-switch-conversion.c
+++ b/gcc/tree-switch-conversion.c
@@ -775,8 +775,8 @@ check_final_bb (struct switch_conv_info *info)
 		  return false; /* Non-invariant argument.  */
 		}
 	      reloc = initializer_constant_valid_p (val, TREE_TYPE (val));
-	      if ((flag_pic && reloc != null_pointer_node)
-		  || (!flag_pic && reloc == NULL_TREE))
+	      if ((GCC_OPTION (flag_pic) && reloc != null_pointer_node)
+		  || (!GCC_OPTION (flag_pic) && reloc == NULL_TREE))
 		{
 		  if (reloc)
 		    info->reason
@@ -1471,7 +1471,7 @@ do_switchconv (void)
 static bool
 switchconv_gate (void)
 {
-  return flag_tree_switch_conversion != 0;
+  return GCC_OPTION (flag_tree_switch_conversion) != 0;
 }
 
 namespace {
diff --git a/gcc/tree-tailcall.c b/gcc/tree-tailcall.c
index 3488c2f..f79b53b 100644
--- a/gcc/tree-tailcall.c
+++ b/gcc/tree-tailcall.c
@@ -314,7 +314,7 @@ process_assignment (gimple stmt, gimple_stmt_iterator call, tree *m,
   /* Accumulator optimizations will reverse the order of operations.
      We can only do that for floating-point types if we're assuming
      that addition and multiplication are associative.  */
-  if (!flag_associative_math)
+  if (!GCC_OPTION (flag_associative_math))
     if (FLOAT_TYPE_P (TREE_TYPE (DECL_RESULT (current_function_decl))))
       return false;
 
@@ -1074,7 +1074,7 @@ execute_tail_recursion (void)
 static bool
 gate_tail_calls (void)
 {
-  return flag_optimize_sibling_calls != 0 && dbg_cnt (tail_call);
+  return GCC_OPTION (flag_optimize_sibling_calls) != 0 && dbg_cnt (tail_call);
 }
 
 static unsigned int
diff --git a/gcc/tree-vect-data-refs.c b/gcc/tree-vect-data-refs.c
index fbc35a3..7e5923f 100644
--- a/gcc/tree-vect-data-refs.c
+++ b/gcc/tree-vect-data-refs.c
@@ -719,7 +719,7 @@ vect_compute_data_ref_alignment (struct data_reference *dr)
 	 RTL for other functions.  Most global variables should
 	 have been aligned during the IPA increase_alignment pass.  */
       if (!vect_can_force_dr_alignment_p (base, TYPE_ALIGN (vectype))
-	  || (TREE_STATIC (base) && flag_section_anchors))
+	  || (TREE_STATIC (base) && GCC_OPTION (flag_section_anchors)))
 	{
 	  if (dump_enabled_p ())
 	    {
diff --git a/gcc/tree-vect-generic.c b/gcc/tree-vect-generic.c
index d00a4b4..d002e7e 100644
--- a/gcc/tree-vect-generic.c
+++ b/gcc/tree-vect-generic.c
@@ -969,7 +969,7 @@ expand_vector_operation (gimple_stmt_iterator *gsi, tree type, tree compute_type
 	  tree rhs2 = gimple_assign_rhs2 (assign);
 	  tree ret;
 
-	  if (!optimize
+	  if (!GCC_OPTION (optimize)
 	      || !VECTOR_INTEGER_TYPE_P (type)
 	      || TREE_CODE (rhs2) != VECTOR_CST)
 	    break;
@@ -1371,7 +1371,7 @@ expand_vector_operations_1 (gimple_stmt_iterator *gsi)
       && TREE_CODE (lhs) == SSA_NAME
       && VECTOR_MODE_P (TYPE_MODE (TREE_TYPE (lhs)))
       && !gimple_clobber_p (stmt)
-      && optimize)
+      && GCC_OPTION (optimize))
     {
       optimize_vector_constructor (gsi);
       return;
diff --git a/gcc/tree-vect-loop.c b/gcc/tree-vect-loop.c
index df6ab6f..4f36452 100644
--- a/gcc/tree-vect-loop.c
+++ b/gcc/tree-vect-loop.c
@@ -596,9 +596,9 @@ vect_is_simple_iv_evolution (unsigned loop_nb, tree access_fn, tree * init,
 	      && flow_bb_inside_loop_p (get_loop (cfun, loop_nb), bb))
 	  || (!INTEGRAL_TYPE_P (TREE_TYPE (step_expr))
 	      && (!SCALAR_FLOAT_TYPE_P (TREE_TYPE (step_expr))
-		  || !flag_associative_math)))
+		  || !GCC_OPTION (flag_associative_math))))
       && (TREE_CODE (step_expr) != REAL_CST
-	  || !flag_associative_math))
+	  || !GCC_OPTION (flag_associative_math)))
     {
       if (dump_enabled_p ())
         dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
@@ -2437,7 +2437,7 @@ vect_is_simple_reduction_1 (loop_vec_info loop_info, gimple phi,
      outer-loop vectorization is safe.  */
 
   /* CHECKME: check for !flag_finite_math_only too?  */
-  if (SCALAR_FLOAT_TYPE_P (type) && !flag_associative_math
+  if (SCALAR_FLOAT_TYPE_P (type) && !GCC_OPTION (flag_associative_math)
       && check_reduction)
     {
       /* Changing the order of operations changes the semantics.  */
diff --git a/gcc/tree-vectorizer.c b/gcc/tree-vectorizer.c
index a051dce..97b61d9 100644
--- a/gcc/tree-vectorizer.c
+++ b/gcc/tree-vectorizer.c
@@ -415,7 +415,7 @@ vectorize_loops (void)
   FOR_EACH_LOOP (loop, 0)
     if (loop->dont_vectorize)
       any_ifcvt_loops = true;
-    else if ((flag_tree_loop_vectorize
+    else if ((GCC_OPTION (flag_tree_loop_vectorize)
 	      && optimize_loop_nest_for_speed_p (loop))
 	     || loop->force_vect)
       {
@@ -616,7 +616,7 @@ execute_vect_slp (void)
 static bool
 gate_vect_slp (void)
 {
-  return flag_tree_slp_vectorize != 0;
+  return GCC_OPTION (flag_tree_slp_vectorize) != 0;
 }
 
 namespace {
@@ -706,7 +706,7 @@ increase_alignment (void)
 static bool
 gate_increase_alignment (void)
 {
-  return flag_section_anchors && flag_tree_loop_vectorize;
+  return GCC_OPTION (flag_section_anchors) && GCC_OPTION (flag_tree_loop_vectorize);
 }
 
 
diff --git a/gcc/tree-vectorizer.h b/gcc/tree-vectorizer.h
index f8efe47..a971986 100644
--- a/gcc/tree-vectorizer.h
+++ b/gcc/tree-vectorizer.h
@@ -953,9 +953,9 @@ static inline bool
 unlimited_cost_model (loop_p loop)
 {
   if (loop != NULL && loop->force_vect
-      && flag_simd_cost_model != VECT_COST_MODEL_DEFAULT)
-    return flag_simd_cost_model == VECT_COST_MODEL_UNLIMITED;
-  return (flag_vect_cost_model == VECT_COST_MODEL_UNLIMITED);
+      && GCC_OPTION (flag_simd_cost_model) != VECT_COST_MODEL_DEFAULT)
+    return GCC_OPTION (flag_simd_cost_model) == VECT_COST_MODEL_UNLIMITED;
+  return (GCC_OPTION (flag_vect_cost_model) == VECT_COST_MODEL_UNLIMITED);
 }
 
 /* Source location */
diff --git a/gcc/tree-vrp.c b/gcc/tree-vrp.c
index 3060210..ade3359 100644
--- a/gcc/tree-vrp.c
+++ b/gcc/tree-vrp.c
@@ -1079,11 +1079,11 @@ gimple_stmt_nonzero_warnv_p (gimple stmt, bool *strict_overflow_p)
       {
 	tree fndecl = gimple_call_fndecl (stmt);
 	if (!fndecl) return false;
-	if (flag_delete_null_pointer_checks && !flag_check_new
+	if (GCC_OPTION (flag_delete_null_pointer_checks) && !GCC_OPTION (flag_check_new)
 	    && DECL_IS_OPERATOR_NEW (fndecl)
 	    && !TREE_NOTHROW (fndecl))
 	  return true;
-	if (flag_delete_null_pointer_checks && 
+	if (GCC_OPTION (flag_delete_null_pointer_checks) && 
 	    lookup_attribute ("returns_nonnull",
 			      TYPE_ATTRIBUTES (gimple_call_fntype (stmt))))
 	  return true;
@@ -2822,11 +2822,11 @@ extract_range_from_binary_expr_1 (value_range_t *vr,
 	      vr1p.max = vr1p.min;
 	      /* We have to use a wrapping multiply though as signed overflow
 		 on lshifts is implementation defined in C89.  */
-	      saved_flag_wrapv = flag_wrapv;
-	      flag_wrapv = 1;
+	      saved_flag_wrapv = GCC_OPTION (flag_wrapv);
+	      GCC_OPTION (flag_wrapv) = 1;
 	      extract_range_from_binary_expr_1 (vr, MULT_EXPR, expr_type,
 						&vr0, &vr1p);
-	      flag_wrapv = saved_flag_wrapv;
+	      GCC_OPTION (flag_wrapv) = saved_flag_wrapv;
 	      return;
 	    }
 	  else if (code == LSHIFT_EXPR
@@ -3777,15 +3777,15 @@ extract_range_basic (value_range_t *vr, gimple stmt)
 	}
       if (subcode != ERROR_MARK)
 	{
-	  bool saved_flag_wrapv = flag_wrapv;
+	  bool saved_flag_wrapv = GCC_OPTION (flag_wrapv);
 	  /* Pretend the arithmetics is wrapping.  If there is
 	     any overflow, we'll complain, but will actually do
 	     wrapping operation.  */
-	  flag_wrapv = 1;
+	  GCC_OPTION (flag_wrapv) = 1;
 	  extract_range_from_binary_expr (vr, subcode, type,
 					  gimple_call_arg (stmt, 0),
 					  gimple_call_arg (stmt, 1));
-	  flag_wrapv = saved_flag_wrapv;
+	  GCC_OPTION (flag_wrapv) = saved_flag_wrapv;
 
 	  /* If for both arguments vrp_valueize returned non-NULL,
 	     this should have been already folded and if not, it
@@ -7155,7 +7155,7 @@ vrp_evaluate_conditional (enum tree_code code, tree op0, tree op1, gimple stmt)
 	}
     }
 
-  if (warn_type_limits
+  if (GCC_OPTION (warn_type_limits)
       && ret && only_ranges
       && TREE_CODE_CLASS (code) == tcc_comparison
       && TREE_CODE (op0) == SSA_NAME)
@@ -9697,7 +9697,7 @@ vrp_finalize (void)
   substitute_and_fold (op_with_constant_singleton_value_range,
 		       vrp_fold_stmt, false);
 
-  if (warn_array_bounds)
+  if (GCC_OPTION (warn_array_bounds))
     check_all_array_refs ();
 
   /* We must identify jump threading opportunities before we release
@@ -9870,7 +9870,7 @@ execute_vrp (void)
 static bool
 gate_vrp (void)
 {
-  return flag_tree_vrp != 0;
+  return GCC_OPTION (flag_tree_vrp) != 0;
 }
 
 namespace {
diff --git a/gcc/tree.c b/gcc/tree.c
index efee5e6..5162481 100644
--- a/gcc/tree.c
+++ b/gcc/tree.c
@@ -4693,7 +4693,7 @@ attribute_value_equal (const_tree attr1, const_tree attr2)
     return (simple_cst_list_equal (TREE_VALUE (attr1),
 				   TREE_VALUE (attr2)) == 1);
 
-  if ((flag_openmp || flag_openmp_simd)
+  if ((GCC_OPTION (flag_openmp) || GCC_OPTION (flag_openmp_simd))
       && TREE_VALUE (attr1) && TREE_VALUE (attr2)
       && TREE_CODE (TREE_VALUE (attr1)) == OMP_CLAUSE
       && TREE_CODE (TREE_VALUE (attr2)) == OMP_CLAUSE)
@@ -5107,7 +5107,7 @@ save_debug_info_for_decl (tree t)
 {
   /*struct saved_debug_info_d *sdi;*/
 
-  gcc_assert (debug_info_level > DINFO_LEVEL_TERSE && t && DECL_P (t));
+  gcc_assert (GCC_OPTION (debug_info_level) > DINFO_LEVEL_TERSE && t && DECL_P (t));
 
   /* FIXME.  Partial implementation for saving debug info removed.  */
 }
@@ -5121,7 +5121,7 @@ save_debug_info_for_type (tree t)
 {
   /*struct saved_debug_info_d *sdi;*/
 
-  gcc_assert (debug_info_level > DINFO_LEVEL_TERSE && t && TYPE_P (t));
+  gcc_assert (GCC_OPTION (debug_info_level) > DINFO_LEVEL_TERSE && t && TYPE_P (t));
 
   /* FIXME.  Partial implementation for saving debug info removed.  */
 }
@@ -5136,13 +5136,13 @@ add_tree_to_fld_list (tree t, struct free_lang_data_d *fld)
   if (DECL_P (t))
     {
       fld->decls.safe_push (t);
-      if (debug_info_level > DINFO_LEVEL_TERSE)
+      if (GCC_OPTION (debug_info_level) > DINFO_LEVEL_TERSE)
 	save_debug_info_for_decl (t);
     }
   else if (TYPE_P (t))
     {
       fld->types.safe_push (t);
-      if (debug_info_level > DINFO_LEVEL_TERSE)
+      if (GCC_OPTION (debug_info_level) > DINFO_LEVEL_TERSE)
 	save_debug_info_for_type (t);
     }
   else
@@ -5582,8 +5582,8 @@ free_lang_data (void)
   unsigned i;
 
   /* If we are the LTO frontend we have freed lang-specific data already.  */
-  if (in_lto_p
-      || !flag_generate_lto)
+  if (GCC_OPTION (in_lto_p)
+      || !GCC_OPTION (flag_generate_lto))
     return 0;
 
   /* Allocate and assign alias sets to the standard integer types
@@ -6037,7 +6037,7 @@ handle_dll_attribute (tree * pnode, tree name, tree args, int flags,
     }
   else if (TREE_CODE (node) == FUNCTION_DECL
 	   && DECL_DECLARED_INLINE_P (node)
-	   && flag_keep_inline_dllexport)
+	   && GCC_OPTION (flag_keep_inline_dllexport))
     /* An exported function, even if inline, must be emitted.  */
     DECL_EXTERNAL (node) = 0;
 
@@ -9102,7 +9102,7 @@ get_file_function_name (const char *type)
 	   || (strncmp (type, "sub_", 4) == 0
 	       && (type[4] == 'I' || type[4] == 'D')))
     {
-      const char *file = main_input_filename;
+      const char *file = GCC_OPTION (main_input_filename);
       if (! file)
 	file = LOCATION_FILE (input_location);
       /* Just use the file's basename, because the full pathname
@@ -9116,7 +9116,7 @@ get_file_function_name (const char *type)
 	 unit, so use what we do have and throw in some randomness.  */
       unsigned len;
       const char *name = weak_global_object_name;
-      const char *file = main_input_filename;
+      const char *file = GCC_OPTION (main_input_filename);
 
       if (! name)
 	name = "";
@@ -9850,7 +9850,7 @@ set_call_expr_flags (tree decl, int flags)
   if (flags & ECF_LEAF)
     DECL_ATTRIBUTES (decl) = tree_cons (get_identifier ("leaf"),
 					NULL, DECL_ATTRIBUTES (decl));
-  if ((flags & ECF_TM_PURE) && flag_tm)
+  if ((flags & ECF_TM_PURE) && GCC_OPTION (flag_tm))
     apply_tm_attr (decl, get_identifier ("transaction_pure"));
   /* Looping const or pure is implied by noreturn.
      There is currently no way to declare looping const or looping pure alone.  */
@@ -9941,7 +9941,7 @@ build_common_builtin_nodes (void)
 			ECF_MALLOC | ECF_NOTHROW | ECF_LEAF);
 
   /* If we're checking the stack, `alloca' can throw.  */
-  if (flag_stack_check)
+  if (GCC_OPTION (flag_stack_check))
     {
       TREE_NOTHROW (builtin_decl_explicit (BUILT_IN_ALLOCA)) = 0;
       TREE_NOTHROW (builtin_decl_explicit (BUILT_IN_ALLOCA_WITH_ALIGN)) = 0;
@@ -11846,7 +11846,7 @@ types_same_for_odr (tree type1, tree type2)
     return true;
 
 #ifndef ENABLE_CHECKING
-  if (!in_lto_p)
+  if (!GCC_OPTION (in_lto_p))
     return false;
 #endif
 
@@ -11895,7 +11895,7 @@ types_same_for_odr (tree type1, tree type2)
   if (!same_for_odr (TYPE_CONTEXT (type1), TYPE_CONTEXT (type2)))
     return false;
   /* When not in LTO the MAIN_VARIANT check should be the same.  */
-  gcc_assert (in_lto_p);
+  gcc_assert (GCC_OPTION (in_lto_p));
     
   return true;
 }
@@ -12055,7 +12055,7 @@ warn_deprecated_use (tree node, tree attr)
 {
   const char *msg;
 
-  if (node == 0 || !warn_deprecated_decl)
+  if (node == 0 || !GCC_OPTION (warn_deprecated_decl))
     return;
 
   if (!attr)
diff --git a/gcc/tree.h b/gcc/tree.h
index 71d6832..aba8a99 100644
--- a/gcc/tree.h
+++ b/gcc/tree.h
@@ -741,7 +741,7 @@ extern void omp_clause_range_check_failed (const_tree, const char *, int,
 /* True if overflow wraps around for the given integral type.  That
    is, TYPE_MAX + 1 == TYPE_MIN.  */
 #define TYPE_OVERFLOW_WRAPS(TYPE) \
-  (TYPE_UNSIGNED (TYPE) || flag_wrapv)
+  (TYPE_UNSIGNED (TYPE) || GCC_OPTION (flag_wrapv))
 
 /* True if overflow is undefined for the given integral type.  We may
    optimize on the assumption that values in the type never overflow.
@@ -752,15 +752,15 @@ extern void omp_clause_range_check_failed (const_tree, const char *, int,
    other cases it will be appropriate to simply set a flag and let the
    caller decide whether a warning is appropriate or not.  */
 #define TYPE_OVERFLOW_UNDEFINED(TYPE) \
-  (!TYPE_UNSIGNED (TYPE) && !flag_wrapv && !flag_trapv && flag_strict_overflow)
+  (!TYPE_UNSIGNED (TYPE) && !GCC_OPTION (flag_wrapv) && !GCC_OPTION (flag_trapv) && GCC_OPTION (flag_strict_overflow))
 
 /* True if overflow for the given integral type should issue a
    trap.  */
 #define TYPE_OVERFLOW_TRAPS(TYPE) \
-  (!TYPE_UNSIGNED (TYPE) && flag_trapv)
+  (!TYPE_UNSIGNED (TYPE) && GCC_OPTION (flag_trapv))
 
 /* True if pointer types have undefined overflow.  */
-#define POINTER_TYPE_OVERFLOW_UNDEFINED (flag_strict_overflow)
+#define POINTER_TYPE_OVERFLOW_UNDEFINED (GCC_OPTION (flag_strict_overflow))
 
 /* Nonzero in a VAR_DECL or STRING_CST means assembler code has been written.
    Nonzero in a FUNCTION_DECL means that the function has been compiled.
@@ -1011,7 +1011,7 @@ extern void omp_clause_range_check_failed (const_tree, const char *, int,
   ((int)TREE_INT_CST_LOW (VL_EXP_CHECK (NODE)->exp.operands[0]))
 
 /* Nonzero if is_gimple_debug() may possibly hold.  */
-#define MAY_HAVE_DEBUG_STMTS    (flag_var_tracking_assignments)
+#define MAY_HAVE_DEBUG_STMTS    (GCC_OPTION (flag_var_tracking_assignments))
 
 /* In a LOOP_EXPR node.  */
 #define LOOP_EXPR_BODY(NODE) TREE_OPERAND_CHECK_CODE (NODE, LOOP_EXPR, 0)
diff --git a/gcc/tsan.c b/gcc/tsan.c
index 2e32cd2..afc66b70 100644
--- a/gcc/tsan.c
+++ b/gcc/tsan.c
@@ -130,7 +130,7 @@ instrument_expr (gimple_stmt_iterator gsi, tree expr, bool is_write)
       struct pt_solution pt;
       memset (&pt, 0, sizeof (pt));
       pt.escaped = 1;
-      pt.ipa_escaped = flag_ipa_pta != 0;
+      pt.ipa_escaped = GCC_OPTION (flag_ipa_pta) != 0;
       pt.nonlocal = 1;
       if (!pt_solution_includes (&pt, base))
 	return false;
@@ -720,7 +720,7 @@ tsan_pass (void)
 static bool
 tsan_gate (void)
 {
-  return (flag_sanitize & SANITIZE_THREAD) != 0;
+  return (GCC_OPTION (flag_sanitize) & SANITIZE_THREAD) != 0;
 }
 
 /* Inserts __tsan_init () into the list of CTORs.  */
@@ -782,7 +782,7 @@ make_pass_tsan (gcc::context *ctxt)
 static bool
 tsan_gate_O0 (void)
 {
-  return (flag_sanitize & SANITIZE_THREAD) != 0 && !optimize;
+  return (GCC_OPTION (flag_sanitize) & SANITIZE_THREAD) != 0 && !GCC_OPTION (optimize);
 }
 
 namespace {
diff --git a/gcc/ubsan.c b/gcc/ubsan.c
index 22470da..ccad366 100644
--- a/gcc/ubsan.c
+++ b/gcc/ubsan.c
@@ -754,13 +754,13 @@ instrument_bool_enum_load (gimple_stmt_iterator *gsi)
   tree type = TREE_TYPE (rhs);
   tree minv = NULL_TREE, maxv = NULL_TREE;
 
-  if (TREE_CODE (type) == BOOLEAN_TYPE && (flag_sanitize & SANITIZE_BOOL))
+  if (TREE_CODE (type) == BOOLEAN_TYPE && (GCC_OPTION (flag_sanitize) & SANITIZE_BOOL))
     {
       minv = boolean_false_node;
       maxv = boolean_true_node;
     }
   else if (TREE_CODE (type) == ENUMERAL_TYPE
-	   && (flag_sanitize & SANITIZE_ENUM)
+	   && (GCC_OPTION (flag_sanitize) & SANITIZE_ENUM)
 	   && TREE_TYPE (type) != NULL_TREE
 	   && TREE_CODE (TREE_TYPE (type)) == INTEGER_TYPE
 	   && (TYPE_PRECISION (TREE_TYPE (type))
@@ -861,11 +861,11 @@ ubsan_pass (void)
 	      continue;
 	    }
 
-	  if ((flag_sanitize & SANITIZE_SI_OVERFLOW)
+	  if ((GCC_OPTION (flag_sanitize) & SANITIZE_SI_OVERFLOW)
 	      && is_gimple_assign (stmt))
 	    instrument_si_overflow (gsi);
 
-	  if (flag_sanitize & SANITIZE_NULL)
+	  if (GCC_OPTION (flag_sanitize) & SANITIZE_NULL)
 	    {
 	      if (gimple_store_p (stmt))
 		instrument_null (gsi, true);
@@ -873,7 +873,7 @@ ubsan_pass (void)
 		instrument_null (gsi, false);
 	    }
 
-	  if (flag_sanitize & (SANITIZE_BOOL | SANITIZE_ENUM)
+	  if (GCC_OPTION (flag_sanitize) & (SANITIZE_BOOL | SANITIZE_ENUM)
 	      && gimple_assign_load_p (stmt))
 	    instrument_bool_enum_load (&gsi);
 
@@ -886,7 +886,7 @@ ubsan_pass (void)
 static bool
 gate_ubsan (void)
 {
-  return flag_sanitize & (SANITIZE_NULL | SANITIZE_SI_OVERFLOW
+  return GCC_OPTION (flag_sanitize) & (SANITIZE_NULL | SANITIZE_SI_OVERFLOW
 			  | SANITIZE_BOOL | SANITIZE_ENUM);
 }
 
diff --git a/gcc/value-prof.c b/gcc/value-prof.c
index 2890093..aba2ad2 100644
--- a/gcc/value-prof.c
+++ b/gcc/value-prof.c
@@ -610,7 +610,7 @@ check_counter (gimple stmt, const char * name,
       locus = (stmt != NULL)
               ? gimple_location (stmt)
               : DECL_SOURCE_LOCATION (current_function_decl);
-      if (flag_profile_correction)
+      if (GCC_OPTION (flag_profile_correction))
         {
           if (dump_enabled_p ())
             dump_printf_loc (MSG_MISSED_OPTIMIZATION, locus,
@@ -1156,7 +1156,7 @@ gimple_mod_subtract_transform (gimple_stmt_iterator *si)
       return false;
     }
 
-  if (flag_profile_correction && count1 + count2 > all)
+  if (GCC_OPTION (flag_profile_correction) && count1 + count2 > all)
       all = count1 + count2;
 
   gcc_assert (count1 + count2 <= all);
diff --git a/gcc/var-tracking.c b/gcc/var-tracking.c
index 65d8285..3889c3c 100644
--- a/gcc/var-tracking.c
+++ b/gcc/var-tracking.c
@@ -1737,7 +1737,7 @@ unshare_variable (dataflow_set *set, variable_def **slot, variable var,
   new_var->onepart = var->onepart;
   new_var->in_changed_variables = false;
 
-  if (! flag_var_tracking_uninit)
+  if (! GCC_OPTION (flag_var_tracking_uninit))
     initialized = VAR_INIT_STATUS_INITIALIZED;
 
   for (i = 0; i < var->n_var_parts; i++)
@@ -1876,7 +1876,7 @@ get_init_value (dataflow_set *set, rtx loc, decl_or_value dv)
   int i;
   enum var_init_status ret_val = VAR_INIT_STATUS_UNKNOWN;
 
-  if (! flag_var_tracking_uninit)
+  if (! GCC_OPTION (flag_var_tracking_uninit))
     return VAR_INIT_STATUS_INITIALIZED;
 
   var = shared_hash_find (set->vars, dv);
@@ -3088,7 +3088,7 @@ variable_union (variable src, dataflow_set *set)
       dst->var_part[k].cur_loc = NULL;
     }
 
-  if (flag_var_tracking_uninit)
+  if (GCC_OPTION (flag_var_tracking_uninit))
     for (i = 0; i < src->n_var_parts && i < dst->n_var_parts; i++)
       {
 	location_chain node, node2;
@@ -6567,7 +6567,7 @@ find_src_status (dataflow_set *in, rtx src)
   tree decl = NULL_TREE;
   enum var_init_status status = VAR_INIT_STATUS_UNINITIALIZED;
 
-  if (! flag_var_tracking_uninit)
+  if (! GCC_OPTION (flag_var_tracking_uninit))
     status = VAR_INIT_STATUS_INITIALIZED;
 
   if (src && REG_P (src))
@@ -6805,7 +6805,7 @@ compute_bb_dataflow (basic_block bb)
 
 		      if (copied_p)
 			{
-			  if (flag_var_tracking_uninit)
+			  if (GCC_OPTION (flag_var_tracking_uninit))
 			    {
 			      status = find_src_status (in, src);
 
@@ -6874,7 +6874,7 @@ compute_bb_dataflow (basic_block bb)
 		  loc = SET_DEST (loc);
 		}
 
-	      if (! flag_var_tracking_uninit)
+	      if (! GCC_OPTION (flag_var_tracking_uninit))
 		src_status = VAR_INIT_STATUS_INITIALIZED;
 	      else
 		{
@@ -7518,7 +7518,7 @@ set_slot_part (dataflow_set *set, rtx loc, variable_def **slot,
   gcc_checking_assert (offset == 0 || !onepart);
   gcc_checking_assert (loc != dv_as_opaque (dv));
 
-  if (! flag_var_tracking_uninit)
+  if (! GCC_OPTION (flag_var_tracking_uninit))
     initialized = VAR_INIT_STATUS_INITIALIZED;
 
   if (!var)
@@ -7792,7 +7792,7 @@ clobber_slot_part (dataflow_set *set, rtx loc, variable_def **slot,
 	{
 	  next = node->next;
 	  if (node->loc != loc
-	      && (!flag_var_tracking_uninit
+	      && (!GCC_OPTION (flag_var_tracking_uninit)
 		  || !set_src
 		  || MEM_P (set_src)
 		  || !rtx_equal_p (set_src, node->set_src)))
@@ -8726,7 +8726,7 @@ emit_note_insn_var_location (variable_def **varp, emit_note_data *data)
   if ((unsigned HOST_WIDE_INT) last_limit < TREE_INT_CST_LOW (type_size_unit))
     complete = false;
 
-  if (! flag_var_tracking_uninit)
+  if (! GCC_OPTION (flag_var_tracking_uninit))
     initialized = VAR_INIT_STATUS_INITIALIZED;
 
   note_vl = NULL_RTX;
@@ -10270,7 +10270,7 @@ variable_tracking_main_1 (void)
 {
   bool success;
 
-  if (flag_var_tracking_assignments < 0)
+  if (GCC_OPTION (flag_var_tracking_assignments) < 0)
     {
       delete_debug_insns ();
       return 0;
@@ -10293,14 +10293,14 @@ variable_tracking_main_1 (void)
 
   success = vt_find_locations ();
 
-  if (!success && flag_var_tracking_assignments > 0)
+  if (!success && GCC_OPTION (flag_var_tracking_assignments) > 0)
     {
       vt_finalize ();
 
       delete_debug_insns ();
 
       /* This is later restored by our caller.  */
-      flag_var_tracking_assignments = 0;
+      GCC_OPTION (flag_var_tracking_assignments) = 0;
 
       success = vt_initialize ();
       gcc_assert (success);
@@ -10335,11 +10335,11 @@ unsigned int
 variable_tracking_main (void)
 {
   unsigned int ret;
-  int save = flag_var_tracking_assignments;
+  int save = GCC_OPTION (flag_var_tracking_assignments);
 
   ret = variable_tracking_main_1 ();
 
-  flag_var_tracking_assignments = save;
+  GCC_OPTION (flag_var_tracking_assignments) = save;
 
   return ret;
 }
@@ -10347,7 +10347,7 @@ variable_tracking_main (void)
 static bool
 gate_handle_var_tracking (void)
 {
-  return (flag_var_tracking && !targetm.delay_vartrack);
+  return (GCC_OPTION (flag_var_tracking) && !targetm.delay_vartrack);
 }
 
 
